#!/bin/sh

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


declare -a arg
declare -a val

. ./procinfo_functions

core() {
# this is the central function that check "-m" and "-a" options
# and calls the right subroutines

hostversion

if [ "${arg[1]}" == 'a' ]; then
	arg[0]=m
	arg[8]=s
fi
if [ "${arg[0]}" != 'm' ]; then
	meminfo
	bootloadavg
	modetime
	irqs
	exit
  elif [ "${arg[8]}" = 's' ]; then
	meminfo
	bootloadavg
	modetime
	irqs
	kcmd
	modulesinfo
	devlist
	filesys
  else
	kcmd
	modulesinfo
	devlist
	filesys
  fi
}

parsecmd $@

# check if the luser wants version, help or
# redirect the output on a file
if [ "${arg[7]}" == 'v' ]; then
	versioninfo
	exit
fi
if [ "${arg[6]}" == 'h' ]; then
	printhelp
	exit
fi
if [ "${arg[2]}" == 'F' ]; then
	core > "${val[0]}"
  else
  	core
fi


