#!/bin/sh

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

declare -a arg[]
declare -a var[]
declare -a fields_values[]
declare -a fields_names[]

fields_names[0]=PID
fields_names[1]=TTY
fields_names[2]=TIME
fields_names[3]=ADDR
fields_names[4]=SZ
fields_names[5]=STAT
fields_names[6]=UID
fields_names[7]="USER\t"
fields_names[8]=%CPU
fields_names[9]=%MEM
fields_names[10]=VSZ
fields_names[11]=RSS
fields_names[12]="START\t\t"
fields_names[13]=PENDING
fields_names[14]=BLOCKED
fields_names[15]=IGNORED
fields_names[16]=CAUGHT
fields_names[17]=F
fields_names[18]=PPID
fields_names[19]=PRI
fields_names[20]=NI
fields_names[21]=C
fields_names[22]=S
fields_names[23]=WCHAN
fields_names[24]=CMD
fields_names[25]=COMMAND

ACTUAL_TTY=`tty | cut -d '/' -f 3``tty | cut -d '/' -f 4`
ACTUAL_TTY=`echo $ACTUAL_TTY | sed -e 's/vc/tty/'`
ACTUAL_TTY=`echo $ACTUAL_TTY | sed -e 's/pts/pts\//'`
ACTUAL_UID=`id -u`
ACTUAL_USER=`id -un`
ACTUAL_GID=`id -g`

PASSWDFILE=`cat /etc/passwd`
GROUPFILE=`cat /etc/group`
BOOTTIME=`grep btime /proc/stat | awk '{print $2}'`


. ./ps_functions



# If you give me a PID i use it in the
# "-p <PID>" form
if [[ $@ = [0-9]* ]]; then
        ARG_LINE="-p=$@"
   elif [[ $@ = '' ]]; then
        ARG_LINE="-t=$ACTUAL_TTY"
   else
        ARG_LINE="$@"
fi

for i in $ARG_LINE ; do
        if [[ $i = -[a-zA-Z0-9]* ]]; then
                parsearg_minus $i
           else
                parsearg -$i
        fi
done

# Check for parameters errors/contraddictions
if [ "${arg[7]}" == 'g' ]; then
        print_help
fi
if [ "${arg[2]}" == '-a' ] && [ "${arg[6]}" == 'a' ]; then
        print_help
fi
if [ "${arg[2]}" == '-a' ] && [ "${arg[9]}" == 'x' ]; then
        print_help
fi
if [ "${arg[3]}" == '-d' ] && [ "${arg[6]}" == 'a' ]; then
        print_help
fi
if [ "${arg[3]}" == '-d' ] && [ "${arg[9]}" == 'x' ]; then
        print_help
fi
if [ "${arg[20]}" == '-l' ] && [ "${arg[21]}" == 'u' ]; then
        print_help
fi

# Correcting some fileds
if [ "${fields_values[4]}" == '1' ]; then
        fields_values[3]=0
fi

field_count=0

while [ $field_count -le 25 ]; do
        if [ "${fields_values[$field_count]}" != '' ]; then
                echo -ne "${fields_names[$field_count]}\t"
        fi

        field_count=`expr $field_count + 1`
done
echo


# Start main loop
for PROCESS in `ls /proc/ | grep '\<[0-9]*\>' | tr -d /`
do
	catch_values
	set_and_print_value
done
